#include <Servo.h>

#define S0 2
#define S1 3
#define S2 4
#define S3 5
#define sensorOut 6

Servo topServo;
Servo bottomServo;

int frequency = 0;
int color=0;

void setup() {
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);
  
  digitalWrite(S0, HIGH);
  digitalWrite(S1, LOW);
  
  topServo.attach(7);
  bottomServo.attach(8);
  
  Serial.begin(9600);
}

void loop() {
  // Servomotorul este in pozitia initiala.
  topServo.write(122);
  delay(500);

  // Rotesc servomotorul pana ajunge cu bomboana in dreptul senzorului de culoare.
  for(int i = 122; i > 50; i--) {
    topServo.write(i);
    delay(3);
  }
  delay(500);
  
  color = readColor();
  delay(500);
  
  switch (color) {
    // Rosu
    case 1:
    bottomServo.write(40);
    break;

    // Portocaliu
    case 2:
    bottomServo.write(75);
    break;

    // Verde
    case 3:
    bottomServo.write(100);
    break;

    // Galben
    case 4:
    bottomServo.write(125);
    break;

    // Maro
    case 5:
    bottomServo.write(150);
    break;

    // Albastru
    case 6:
    bottomServo.write(175);
    break;
    
    case 0:
    break;
  }
  delay(300);

  // Rotesc servomotorul pana cand bomboana cade in canal.
  for(int i = 50; i > 29; i--) {
    topServo.write(i);
    delay(2);
  } 
  delay(200);

  // Rotesc servo motorul pana ajunge inapoi in dreptul stivei cu bomboane.
  for(int i = 29; i < 122; i++) {
    topServo.write(i);
    delay(3);
  }
  
  color=0;
}

// Citeste culoarea
int readColor() {
  // Setez sa fie citita frecventa culorii rosii(R)
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
  
  // Citesc frecventa
  frequency = pulseIn(sensorOut, LOW);
  int R = frequency;
  delay(50);
  
  // Setez sa fie citita frecventa culorii verzi(G)
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);
  
  // Citesc frecventa
  frequency = pulseIn(sensorOut, LOW);
  int G = frequency;
  delay(50);
  
  // Setez sa fie citita frecventa culorii albastre(G)
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  
  // Citesc frecventa
  frequency = pulseIn(sensorOut, LOW);
  int B = frequency;
  delay(50);
  
  if(R<45 & R>32 & G<65 & G>55){
    color = 1; // Rosu
  }
  if (G<55 & G>43 & B<47 &B>35){
    color = 2; // Portocaliu
  }
  if(R<53 & R>40 & G<53 & G>40){
    color = 3; // Verde
  }
  if(R<38 & R>24 & G<44 & G>30){
    color = 4; // Galben
  }
  if(R<56 & R>46 & G<65 & G>55){
    color = 5; // Maro
  }
  if (G<58 & G>45 & B<40 &B>26){
    color = 6; // Albastru
  }
  
  return color;  
}
